import javafx.application.Application;
import javafx.beans.value.ChangeListener;
import javafx.beans.value.ObservableValue;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.geometry.Insets;
import javafx.geometry.Pos;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.control.Label;
import javafx.scene.control.PasswordField;
import javafx.scene.control.TextField;
import javafx.scene.layout.HBox;
import javafx.scene.layout.Priority;
import javafx.scene.layout.VBox;
import javafx.stage.Stage;

public class LoginDemoP3Events extends Application /*implements EventHandler<ActionEvent>*/ {
	
	Button okBtn;
	TextField userField;

	public static void main(String[] args) {
		launch(args);
	}

	@Override
	public void start(Stage stage) throws Exception {
		stage.setTitle("Please login");
		VBox root = new VBox();
		root.setSpacing(10);
		root.setPadding(new Insets(10));
		HBox userRow = new HBox();
		VBox.setVgrow(userRow, Priority.ALWAYS);
		userRow.setSpacing(10);
		Label userLabel = new Label("User name");
		userLabel.autosize();
		userField = new TextField();
		// increase/decrease user field height with user row height by binding it
		userField.prefHeightProperty().bind(userRow.heightProperty());
		userField.textProperty().addListener(new UserFieldListener());
		
		HBox.setHgrow(userField, Priority.ALWAYS);
		userField.setPromptText("Enter your user name");
		userRow.getChildren().addAll(userLabel, userField);
		HBox pwRow = new HBox();
		VBox.setVgrow(pwRow, Priority.ALWAYS);
		
		// listen to user field text
		
		
		//pwRow.setMaxHeight(75);
		pwRow.setSpacing(16);
		Label pwLabel = new Label("Password");
		PasswordField pwField = new PasswordField();
		// increase/decrease pw field height with pw row height by binding it
		pwField.prefHeightProperty().bind(pwRow.heightProperty());
		
		HBox.setHgrow(pwField, Priority.ALWAYS);
		pwField.setPromptText("Enter your user password");
		pwRow.getChildren().addAll(pwLabel, pwField);
		HBox buttonRow = new HBox();
		buttonRow.setSpacing(10);
		buttonRow.setAlignment(Pos.CENTER_RIGHT);
		okBtn = new Button("Ok");
		okBtn.setOnAction(new OkButtonHandler());
		
		
		Button cancelBtn = new Button("Cancel");
		cancelBtn.setOnAction(new CancelButtonHandler());
		
		buttonRow.getChildren().addAll(okBtn, cancelBtn);
		root.getChildren().addAll(userRow, pwRow, buttonRow);
		Scene scene = new Scene(root);
		stage.setScene(scene);
		stage.sizeToScene();
		
		// add some action listeners to respond to buttons
		
		
		
		// limit the range of window sizes allowed
		stage.setMinWidth(252);
		stage.setMaxWidth(600);
		stage.setMinHeight(154);
		stage.setMaxHeight(180);
		stage.show();
	}

//	@Override
//	public void handle(ActionEvent event) {
//		System.out.println("Button pressed");
//		Button btn = (Button)event.getSource();
//		if (btn.getText().equals("Ok")) { // if (btn == okBtn)
//			System.out.println("Ok pressed");
//		} else {
//			System.out.println("Cancel pressed");
//		}
//	}
	
	private class OkButtonHandler implements EventHandler<ActionEvent> {

		@Override
		public void handle(ActionEvent event) {
			System.out.println("Ok pressed");
		}
		
	}
	
	private class CancelButtonHandler implements EventHandler<ActionEvent> {

		@Override
		public void handle(ActionEvent event) {
			System.out.println("Cancel pressed");
		}
		
	}
	
	private class UserFieldListener implements ChangeListener<String> {

		@Override
		public void changed(ObservableValue<? extends String> observable, String oldValue, String newValue) {
			System.out.println("Username changed to " + newValue);
			if (newValue.length() > 8) {
				userField.setText(newValue.substring(0, 8));
			}
			
		}
		
	}
	
	
}
